local Talented = Talented
local L = LibStub("AceLocale-3.0"):GetLocale("Talented")

function Talented:ApplyTalentPoints()
	assert (GetCVarBool"previewTalents")

	local template = self.template
	local pet = not RAID_CLASS_COLORS[template.class]

	ResetGroupPreviewTalentPoints(pet)

	local cp = GetUnspentTalentPoints(nil, pet)
	local group = GetActiveTalentGroup()

	for tab, tree in ipairs(self:UncompressSpellData(template.class)) do
		local ttab = template[tab]
		for index = 1, #tree do
			local delta = ttab[index] - select(5, GetTalentInfo(tab, index, nil, pet))
			if delta > 0 then
				AddPreviewTalentPoints(tab, index, delta, pet, group)
				cp = cp - delta
			end
		end
	end
	if cp < 0 then
		Talented:Print(L["Error while applying talents! Not enough talent points!"])
		ResetGroupPreviewTalentPoints(pet)
		Talented:EnableUI(true)
	else
		LearnPreviewTalents(pet)
	end
end

function Talented:CheckTalentPointsApplied()
	local template = self.template
	local pet = not RAID_CLASS_COLORS[template.class]
	local failed
	for tab, tree in ipairs(self:UncompressSpellData(template.class)) do
		local ttab = template[tab]
		for index = 1, #tree do
			local delta = ttab[index] - select(5, GetTalentInfo(tab, index, nil, pet))
			if delta > 0 then
				failed = true
				break
			end
		end
	end
	if failed then
		Talented:Print(L["Error while applying talents! some of the request talents were not set!"])
	else
		local cp = GetUnspentTalentPoints(nil, pet)
		Talented:Print(L["Template applied successfully, %d talent points remaining."], cp)
	end
	Talented:EnableUI(true)
end
