local select = select
local ipairs = ipairs
local GetTalentInfo = GetTalentInfo
local GRAY_FONT_COLOR = GRAY_FONT_COLOR
local NORMAL_FONT_COLOR = NORMAL_FONT_COLOR
local GREEN_FONT_COLOR = GREEN_FONT_COLOR
local RED_FONT_COLOR = RED_FONT_COLOR
local LIGHTBLUE_FONT_COLOR = { r = 0.5, g = 0.6, b = 1 }
local GRAY_FONT_COLOR = GRAY_FONT_COLOR
local Talented = Talented

local L = LibStub("AceLocale-3.0"):GetLocale("Talented")

function Talented:UpdateCurrentTemplate()
	local class = select(2, UnitClass"player")
	local info = self:UncompressSpellData(class)
	if not self.alternates then self.alternates = {} end
	for talentGroup = 1, GetNumTalentGroups() do
		local template = self.alternates[talentGroup]
		if not template then
			template = {
				talentGroup = talentGroup,
				name = "Spec"..talentGroup,
				class = class,
			}
		end
		local total = 0
		for tab, tree in ipairs(info) do
			local ttab = template[tab]
			if not ttab then
				ttab = {}
				template[tab] = ttab
			end
			for index = 1, #tree do
				local rank = select(5, GetTalentInfo(tab, index, nil, nil, talentGroup))
				ttab[index] = rank
				total = total + rank
			end
		end
		self.alternates[talentGroup] = template
		if self.template == template then
			self:UpdateTooltip()
		end
		for _, view in self:IterateTalentViews(template) do
			view:Update()
		end
	end
end

function Talented:GetActiveTalents()
	return self.alternates[GetActiveTalentGroup()]
end

function Talented:UpdateView()
	if not self.base then return end
	self.base.view:Update()
end
